program myweibull_d1
	version 18
	args todo b lnf g H
	tempvar leta lgam p M R
	mleval `leta' = `b', eq(1)
	mleval `lgam' = `b', eq(2)
	local t "$ML_y1"
	local d "$ML_y2"
	quietly {
		generate double `p' = exp(`lgam')
		generate double `M' = (`t'*exp(-`leta'))^`p'
		generate double `R' = ln(`t')-`leta'
		mlsum `lnf' = -`M' + `d'*(`lgam'-`leta' + (`p'-1)*`R')
		if (`todo'==0 | `lnf'>=.) exit
	
		tempvar g1 g2
		generate double `g1' = `p'*(`M'-`d')
		generate double `g2' = `d' - `R'*`p'*(`M'-`d')
		tempname d1 d2
		mlvecsum `lnf' `d1'  = `g1', eq(1)
		mlvecsum `lnf' `d2'  = `g2', eq(2)
		matrix `g' = (`d1',`d2')
	}
end
